"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const qwik = require("@builder.io/qwik");
const jsxRuntime = require("@builder.io/qwik/jsx-runtime");
const target = require("../../constants/target.qwik.cjs");
const abTests = require("../../helpers/ab-tests.qwik.cjs");
const canTrack = require("../../helpers/canTrack.qwik.cjs");
const content = require("../content/content.qwik.cjs");
const inlinedScript = require("../inlined-script.qwik.cjs");
const inlinedStyles = require("../inlined-styles.qwik.cjs");
const helpers = require("./helpers.qwik.cjs");
const ContentVariants = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  qwik._jsxBranch();
  const state = qwik.useStore({
    shouldRenderVariants: helpers.checkShouldRenderVariants({
      canTrack: canTrack.getDefaultCanTrack(props.canTrack),
      content: props.content
    })
  });
  const updateCookieAndStylesScriptStr = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    var _a;
    const [props2] = qwik.useLexicalScope();
    return helpers.getUpdateCookieAndStylesScript(helpers.getVariants(props2.content).map((value) => ({
      id: value.testVariationId,
      testRatio: value.testRatio
    })), ((_a = props2.content) == null ? void 0 : _a.id) || "");
  }, "ContentVariants_component_updateCookieAndStylesScriptStr_useComputed_FtJXWpnoDYg", [
    props
  ]));
  const hideVariantsStyleString = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    const [props2] = qwik.useLexicalScope();
    return helpers.getVariants(props2.content).map((value) => `.variant-${value.testVariationId} { display: none; } `).join("");
  }, "ContentVariants_component_hideVariantsStyleString_useComputed_fQIC0fJqAl4", [
    props
  ]));
  const defaultContent = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    var _a;
    const [props2, state2] = qwik.useLexicalScope();
    return state2.shouldRenderVariants ? {
      ...props2.content,
      testVariationId: (_a = props2.content) == null ? void 0 : _a.id
    } : abTests.handleABTestingSync({
      item: props2.content,
      canTrack: canTrack.getDefaultCanTrack(props2.canTrack)
    });
  }, "ContentVariants_component_defaultContent_useComputed_00q2HQsQPYc", [
    props,
    state
  ]));
  return /* @__PURE__ */ qwik._jsxC(qwik.Fragment, {
    children: [
      !props.isNestedRender && target.TARGET !== "reactNative" ? /* @__PURE__ */ qwik._jsxC(inlinedScript.InlinedScript, {
        id: "builderio-init-variants-fns",
        get scriptStr() {
          return helpers.getInitVariantsFnsScriptString();
        },
        get nonce() {
          return props.nonce || "";
        },
        [qwik._IMMUTABLE]: {
          id: qwik._IMMUTABLE,
          nonce: qwik._fnSignal((p0) => p0.nonce || "", [
            props
          ], 'p0.nonce||""'),
          scriptStr: qwik._IMMUTABLE
        }
      }, 3, "XM_0") : null,
      state.shouldRenderVariants ? /* @__PURE__ */ qwik._jsxC(jsxRuntime.Fragment, {
        children: [
          /* @__PURE__ */ qwik._jsxC(inlinedStyles.InlinedStyles, {
            id: "builderio-variants",
            get styles() {
              return hideVariantsStyleString.value;
            },
            get nonce() {
              return props.nonce || "";
            },
            [qwik._IMMUTABLE]: {
              id: qwik._IMMUTABLE,
              nonce: qwik._fnSignal((p0) => p0.nonce || "", [
                props
              ], 'p0.nonce||""'),
              styles: qwik._fnSignal((p0) => p0.value, [
                hideVariantsStyleString
              ], "p0.value")
            }
          }, 3, "XM_1"),
          /* @__PURE__ */ qwik._jsxC(inlinedScript.InlinedScript, {
            id: "builderio-variants-visibility",
            get scriptStr() {
              return updateCookieAndStylesScriptStr.value;
            },
            get nonce() {
              return props.nonce || "";
            },
            [qwik._IMMUTABLE]: {
              id: qwik._IMMUTABLE,
              nonce: qwik._fnSignal((p0) => p0.nonce || "", [
                props
              ], 'p0.nonce||""'),
              scriptStr: qwik._fnSignal((p0) => p0.value, [
                updateCookieAndStylesScriptStr
              ], "p0.value")
            }
          }, 3, "XM_2"),
          (helpers.getVariants(props.content) || []).map((variant) => {
            return /* @__PURE__ */ qwik._jsxC(content.ContentComponent, {
              get apiHost() {
                return props.apiHost;
              },
              get isNestedRender() {
                return props.isNestedRender;
              },
              get nonce() {
                return props.nonce;
              },
              content: variant,
              showContent: false,
              get model() {
                return props.model;
              },
              get data() {
                return props.data;
              },
              get context() {
                return props.context;
              },
              get apiKey() {
                return props.apiKey;
              },
              get apiVersion() {
                return props.apiVersion;
              },
              get customComponents() {
                return props.customComponents;
              },
              get linkComponent() {
                return props.linkComponent;
              },
              get canTrack() {
                return props.canTrack;
              },
              get locale() {
                return props.locale;
              },
              get enrich() {
                return props.enrich;
              },
              get isSsrAbTest() {
                return state.shouldRenderVariants;
              },
              get blocksWrapper() {
                return props.blocksWrapper;
              },
              get blocksWrapperProps() {
                return props.blocksWrapperProps;
              },
              get contentWrapper() {
                return props.contentWrapper;
              },
              get contentWrapperProps() {
                return props.contentWrapperProps;
              },
              get trustedHosts() {
                return props.trustedHosts;
              },
              [qwik._IMMUTABLE]: {
                apiHost: qwik._fnSignal((p0) => p0.apiHost, [
                  props
                ], "p0.apiHost"),
                apiKey: qwik._fnSignal((p0) => p0.apiKey, [
                  props
                ], "p0.apiKey"),
                apiVersion: qwik._fnSignal((p0) => p0.apiVersion, [
                  props
                ], "p0.apiVersion"),
                blocksWrapper: qwik._fnSignal((p0) => p0.blocksWrapper, [
                  props
                ], "p0.blocksWrapper"),
                blocksWrapperProps: qwik._fnSignal((p0) => p0.blocksWrapperProps, [
                  props
                ], "p0.blocksWrapperProps"),
                canTrack: qwik._fnSignal((p0) => p0.canTrack, [
                  props
                ], "p0.canTrack"),
                contentWrapper: qwik._fnSignal((p0) => p0.contentWrapper, [
                  props
                ], "p0.contentWrapper"),
                contentWrapperProps: qwik._fnSignal((p0) => p0.contentWrapperProps, [
                  props
                ], "p0.contentWrapperProps"),
                context: qwik._fnSignal((p0) => p0.context, [
                  props
                ], "p0.context"),
                customComponents: qwik._fnSignal((p0) => p0.customComponents, [
                  props
                ], "p0.customComponents"),
                data: qwik._fnSignal((p0) => p0.data, [
                  props
                ], "p0.data"),
                enrich: qwik._fnSignal((p0) => p0.enrich, [
                  props
                ], "p0.enrich"),
                isNestedRender: qwik._fnSignal((p0) => p0.isNestedRender, [
                  props
                ], "p0.isNestedRender"),
                isSsrAbTest: qwik._fnSignal((p0) => p0.shouldRenderVariants, [
                  state
                ], "p0.shouldRenderVariants"),
                linkComponent: qwik._fnSignal((p0) => p0.linkComponent, [
                  props
                ], "p0.linkComponent"),
                locale: qwik._fnSignal((p0) => p0.locale, [
                  props
                ], "p0.locale"),
                model: qwik._fnSignal((p0) => p0.model, [
                  props
                ], "p0.model"),
                nonce: qwik._fnSignal((p0) => p0.nonce, [
                  props
                ], "p0.nonce"),
                showContent: qwik._IMMUTABLE,
                trustedHosts: qwik._fnSignal((p0) => p0.trustedHosts, [
                  props
                ], "p0.trustedHosts")
              }
            }, 3, variant.testVariationId);
          })
        ]
      }, 1, "XM_3") : null,
      /* @__PURE__ */ qwik._jsxC(content.ContentComponent, {
        get apiHost() {
          return props.apiHost;
        },
        get nonce() {
          return props.nonce;
        },
        get isNestedRender() {
          return props.isNestedRender;
        },
        get content() {
          return defaultContent.value;
        },
        showContent: true,
        get model() {
          return props.model;
        },
        get data() {
          return props.data;
        },
        get context() {
          return props.context;
        },
        get apiKey() {
          return props.apiKey;
        },
        get apiVersion() {
          return props.apiVersion;
        },
        get customComponents() {
          return props.customComponents;
        },
        get linkComponent() {
          return props.linkComponent;
        },
        get canTrack() {
          return props.canTrack;
        },
        get locale() {
          return props.locale;
        },
        get enrich() {
          return props.enrich;
        },
        get isSsrAbTest() {
          return state.shouldRenderVariants;
        },
        get blocksWrapper() {
          return props.blocksWrapper;
        },
        get blocksWrapperProps() {
          return props.blocksWrapperProps;
        },
        get contentWrapper() {
          return props.contentWrapper;
        },
        get contentWrapperProps() {
          return props.contentWrapperProps;
        },
        get trustedHosts() {
          return props.trustedHosts;
        },
        [qwik._IMMUTABLE]: {
          apiHost: qwik._fnSignal((p0) => p0.apiHost, [
            props
          ], "p0.apiHost"),
          apiKey: qwik._fnSignal((p0) => p0.apiKey, [
            props
          ], "p0.apiKey"),
          apiVersion: qwik._fnSignal((p0) => p0.apiVersion, [
            props
          ], "p0.apiVersion"),
          blocksWrapper: qwik._fnSignal((p0) => p0.blocksWrapper, [
            props
          ], "p0.blocksWrapper"),
          blocksWrapperProps: qwik._fnSignal((p0) => p0.blocksWrapperProps, [
            props
          ], "p0.blocksWrapperProps"),
          canTrack: qwik._fnSignal((p0) => p0.canTrack, [
            props
          ], "p0.canTrack"),
          content: qwik._fnSignal((p0) => p0.value, [
            defaultContent
          ], "p0.value"),
          contentWrapper: qwik._fnSignal((p0) => p0.contentWrapper, [
            props
          ], "p0.contentWrapper"),
          contentWrapperProps: qwik._fnSignal((p0) => p0.contentWrapperProps, [
            props
          ], "p0.contentWrapperProps"),
          context: qwik._fnSignal((p0) => p0.context, [
            props
          ], "p0.context"),
          customComponents: qwik._fnSignal((p0) => p0.customComponents, [
            props
          ], "p0.customComponents"),
          data: qwik._fnSignal((p0) => p0.data, [
            props
          ], "p0.data"),
          enrich: qwik._fnSignal((p0) => p0.enrich, [
            props
          ], "p0.enrich"),
          isNestedRender: qwik._fnSignal((p0) => p0.isNestedRender, [
            props
          ], "p0.isNestedRender"),
          isSsrAbTest: qwik._fnSignal((p0) => p0.shouldRenderVariants, [
            state
          ], "p0.shouldRenderVariants"),
          linkComponent: qwik._fnSignal((p0) => p0.linkComponent, [
            props
          ], "p0.linkComponent"),
          locale: qwik._fnSignal((p0) => p0.locale, [
            props
          ], "p0.locale"),
          model: qwik._fnSignal((p0) => p0.model, [
            props
          ], "p0.model"),
          nonce: qwik._fnSignal((p0) => p0.nonce, [
            props
          ], "p0.nonce"),
          showContent: qwik._IMMUTABLE,
          trustedHosts: qwik._fnSignal((p0) => p0.trustedHosts, [
            props
          ], "p0.trustedHosts")
        }
      }, 3, "XM_4")
    ]
  }, 1, "XM_5");
}, "ContentVariants_component_4tFRiQMMEfM"));
exports.ContentVariants = ContentVariants;
exports.default = ContentVariants;
