"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const qwik = require("@builder.io/qwik");
const isEditing = require("../../functions/is-editing.qwik.cjs");
const logger = require("../../helpers/logger.qwik.cjs");
const runScripts = function runScripts2(props, state, elementRef) {
  if (!elementRef.value || !elementRef.value.getElementsByTagName || typeof window === "undefined")
    return;
  const scripts = elementRef.value.getElementsByTagName("script");
  for (let i = 0; i < scripts.length; i++) {
    const script = scripts[i];
    if (script.src) {
      if (state.scriptsInserted.includes(script.src))
        continue;
      state.scriptsInserted.push(script.src);
      const newScript = document.createElement("script");
      newScript.async = true;
      newScript.src = script.src;
      document.head.appendChild(newScript);
    } else if (!script.type || [
      "text/javascript",
      "application/javascript",
      "application/ecmascript"
    ].includes(script.type)) {
      if (state.scriptsRun.includes(script.innerText))
        continue;
      try {
        state.scriptsRun.push(script.innerText);
        new Function(script.innerText)();
      } catch (error) {
        logger.logger.warn("[BUILDER.IO] `CustomCode`: Error running script:", error);
      }
    }
  }
};
const CustomCode = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  const elementRef = qwik.useSignal();
  const state = qwik.useStore({
    scriptsInserted: [],
    scriptsRun: []
  });
  qwik.useVisibleTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    const [elementRef2, props2, state2] = qwik.useLexicalScope();
    runScripts(props2, state2, elementRef2);
  }, "CustomCode_component_useVisibleTask_S5QgEQZj6YE", [
    elementRef,
    props,
    state
  ]));
  qwik.useVisibleTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(({ track }) => {
    const [elementRef2, props2, state2] = qwik.useLexicalScope();
    track(() => props2.code);
    if (isEditing.isEditing())
      runScripts(props2, state2, elementRef2);
  }, "CustomCode_component_useVisibleTask_1_Re102EQisCE", [
    elementRef,
    props,
    state
  ]));
  return /* @__PURE__ */ qwik._jsxQ("div", {
    ref: elementRef
  }, {
    class: qwik._fnSignal((p0) => "builder-custom-code" + (p0.replaceNodes ? " replace-nodes" : ""), [
      props
    ], '"builder-custom-code"+(p0.replaceNodes?" replace-nodes":"")'),
    dangerouslySetInnerHTML: qwik._fnSignal((p0) => p0.code, [
      props
    ], "p0.code")
  }, null, 3, "bY_0");
}, "CustomCode_component_uYOSy7w7Zqw"));
exports.CustomCode = CustomCode;
exports.default = CustomCode;
exports.runScripts = runScripts;
