"use strict";
Object.defineProperties(exports, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
const qwik = require("@builder.io/qwik");
const image_helpers = require("./image.helpers.qwik.cjs");
const Image = /* @__PURE__ */ qwik.componentQrl(/* @__PURE__ */ qwik.inlinedQrl((props) => {
  var _a, _b, _c, _d, _e, _f;
  qwik._jsxBranch();
  qwik.useStylesScopedQrl(/* @__PURE__ */ qwik.inlinedQrl(STYLES, "Image_component_useStylesScoped_fBMYiVf9fuU"));
  const srcSetToUse = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    var _a2;
    const [props2] = qwik.useLexicalScope();
    const imageToUse = props2.image || props2.src;
    const url = imageToUse;
    if (!url || // We can auto add srcset for cdn.builder.io and shopify
    // images, otherwise you can supply this prop manually
    !(typeof url === "string" && (url.match(/builder\.io/) || url.match(/cdn\.shopify\.com/))))
      return props2.srcset;
    if (props2.noWebp)
      return void 0;
    if (props2.srcset && ((_a2 = props2.image) == null ? void 0 : _a2.includes("builder.io/api/v1/image"))) {
      if (!props2.srcset.includes(props2.image.split("?")[0])) {
        console.debug("Removed given srcset");
        return image_helpers.getSrcSet(url);
      }
    } else if (props2.image && !props2.srcset)
      return image_helpers.getSrcSet(url);
    return image_helpers.getSrcSet(url);
  }, "Image_component_srcSetToUse_useComputed_TZMibf9Gpvw", [
    props
  ]));
  const webpSrcSet = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    var _a2;
    const [props2, srcSetToUse2] = qwik.useLexicalScope();
    if (((_a2 = srcSetToUse2.value) == null ? void 0 : _a2.match(/builder\.io/)) && !props2.noWebp)
      return srcSetToUse2.value.replace(/\?/g, "?format=webp&");
    else
      return "";
  }, "Image_component_webpSrcSet_useComputed_01YCu72BBtA", [
    props,
    srcSetToUse
  ]));
  const aspectRatioCss = qwik.useComputedQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
    const [props2] = qwik.useLexicalScope();
    const aspectRatioStyles = {
      position: "absolute",
      height: "100%",
      width: "100%",
      left: "0px",
      top: "0px"
    };
    const out = props2.aspectRatio ? aspectRatioStyles : void 0;
    return out;
  }, "Image_component_aspectRatioCss_useComputed_yJ1jG0g5fbw", [
    props
  ]));
  qwik.useVisibleTaskQrl(/* @__PURE__ */ qwik.inlinedQrl(() => {
  }, "Image_component_useVisibleTask_pRTGrfPyv0Y"));
  return /* @__PURE__ */ qwik._jsxC(qwik.Fragment, {
    children: [
      /* @__PURE__ */ qwik._jsxQ("picture", null, null, [
        webpSrcSet.value ? /* @__PURE__ */ qwik._jsxQ("source", null, {
          srcset: qwik._fnSignal((p0) => p0.value, [
            webpSrcSet
          ], "p0.value"),
          type: "image/webp"
        }, null, 3, "0A_0") : null,
        /* @__PURE__ */ qwik._jsxQ("img", null, {
          alt: qwik._fnSignal((p0) => p0.altText, [
            props
          ], "p0.altText"),
          class: qwik._fnSignal((p0) => "builder-image" + (p0.className ? " " + p0.className : "") + " img-Image", [
            props
          ], '"builder-image"+(p0.className?" "+p0.className:"")+" img-Image"'),
          fetchPriority: qwik._fnSignal((p0) => p0.highPriority ? "high" : "auto", [
            props
          ], 'p0.highPriority?"high":"auto"'),
          loading: qwik._fnSignal((p0) => p0.highPriority ? "eager" : "lazy", [
            props
          ], 'p0.highPriority?"eager":"lazy"'),
          role: qwik._fnSignal((p0) => p0.altText ? void 0 : "presentation", [
            props
          ], 'p0.altText?undefined:"presentation"'),
          sizes: qwik._fnSignal((p0) => p0.sizes, [
            props
          ], "p0.sizes"),
          src: qwik._fnSignal((p0) => p0.image, [
            props
          ], "p0.image"),
          srcset: qwik._fnSignal((p0) => p0.value, [
            srcSetToUse
          ], "p0.value"),
          style: qwik._fnSignal((p0, p1) => ({
            objectPosition: p1.backgroundPosition || "center",
            objectFit: p1.backgroundSize || "cover",
            ...p0.value
          }), [
            aspectRatioCss,
            props
          ], '{objectPosition:p1.backgroundPosition||"center",objectFit:p1.backgroundSize||"cover",...p0.value}'),
          title: qwik._fnSignal((p0) => p0.title, [
            props
          ], "p0.title")
        }, null, 3, null)
      ], 1, null),
      props.aspectRatio && !(((_b = (_a = props.builderBlock) == null ? void 0 : _a.children) == null ? void 0 : _b.length) && props.fitContent) ? /* @__PURE__ */ qwik._jsxQ("div", null, {
        class: "builder-image-sizer div-Image",
        style: qwik._fnSignal((p0) => ({
          paddingTop: p0.aspectRatio * 100 + "%"
        }), [
          props
        ], '{paddingTop:p0.aspectRatio*100+"%"}')
      }, null, 3, "0A_1") : null,
      ((_d = (_c = props.builderBlock) == null ? void 0 : _c.children) == null ? void 0 : _d.length) && props.fitContent ? /* @__PURE__ */ qwik._jsxC(qwik.Slot, null, 3, "0A_2") : null,
      !props.fitContent && ((_f = (_e = props.builderBlock) == null ? void 0 : _e.children) == null ? void 0 : _f.length) ? /* @__PURE__ */ qwik._jsxQ("div", null, {
        class: "div-Image-2"
      }, /* @__PURE__ */ qwik._jsxC(qwik.Slot, null, 3, "0A_3"), 1, "0A_4") : null
    ]
  }, 1, "0A_5");
}, "Image_component_LRxDkFa1EfU"));
const STYLES = `
.img-Image {
  opacity: 1;
  transition: opacity 0.2s ease-in-out;
}
.div-Image {
  width: 100%;
  pointer-events: none;
  font-size: 0;
}
.div-Image-2 {
  display: flex;
  flex-direction: column;
  align-items: stretch;
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
}
`;
exports.Image = Image;
exports.STYLES = STYLES;
exports.default = Image;
