"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const cookie = require("./cookie.qwik.cjs");
const nullable = require("./nullable.qwik.cjs");
const uuid = require("./uuid.qwik.cjs");
const SESSION_LOCAL_STORAGE_KEY = "builderSessionId";
const getSessionId = async ({ canTrack }) => {
  if (!canTrack)
    return void 0;
  const sessionId = await cookie.getCookie({
    name: SESSION_LOCAL_STORAGE_KEY,
    canTrack
  });
  if (nullable.checkIsDefined(sessionId))
    return sessionId;
  else {
    const newSessionId = createSessionId();
    setSessionId({
      id: newSessionId,
      canTrack
    });
    return newSessionId;
  }
};
const createSessionId = () => uuid.uuid();
const setSessionId = ({ id, canTrack }) => cookie.setCookie({
  name: SESSION_LOCAL_STORAGE_KEY,
  value: id,
  canTrack
});
exports.createSessionId = createSessionId;
exports.getSessionId = getSessionId;
exports.setSessionId = setSessionId;
