"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const target = require("../constants/target.qwik.cjs");
const eventHandlerName = require("./event-handler-name.qwik.cjs");
const getBlockActionsHandler = require("./get-block-actions-handler.qwik.cjs");
function getBlockActions(options) {
  const obj = {};
  const optionActions = options.block.actions ?? {};
  for (const key in optionActions) {
    if (!optionActions.hasOwnProperty(key))
      continue;
    const value = optionActions[key];
    let eventHandlerName$1 = eventHandlerName.getEventHandlerName(key);
    if (options.stripPrefix)
      switch (target.TARGET) {
        case "vue":
          eventHandlerName$1 = eventHandlerName$1.replace("v-on:", "");
          break;
        case "svelte":
          eventHandlerName$1 = eventHandlerName$1.replace("on:", "");
          break;
      }
    obj[eventHandlerName$1] = getBlockActionsHandler.createEventHandler(value, options);
  }
  return obj;
}
exports.getBlockActions = getBlockActions;
